unit MiniParser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, xToolBtn, ExtCtrls;

type
  TfrmMain = class(TForm)
    RichEdit1: TRichEdit;
    Panel1: TPanel;
    xToolButton1: TxToolButton;
    cbMono: TCheckBox;
    dlgOpen: TOpenDialog;
    procedure xToolButton1Click(Sender: TObject);
    procedure cbMonoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure Parse;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

uses
  xProcs, SrcParser;

procedure strToRichEdit(const S: String; aEdit: TRichEdit);
var
  aMem : TMemoryStream;
begin
  aMem:=TMemoryStream.Create;
  try
    aMem.Write(Pointer(S)^, Length(S));
    aMem.Position:=0;
    aEdit.Lines.LoadFromStream(aMem);
  finally
    aMem.Free;
  end;
end;

procedure TfrmMain.xToolButton1Click(Sender: TObject);
begin
  if dlgOpen.Execute then Parse;
end;

procedure TfrmMain.Parse;
const
  UseHtml = False;
var
  aStop : TDateTime;
  S: String;
begin
  if fileExists(dlgOpen.FileName) then
  begin
    aStop:=Time;
    try
      if UseHtml then
         S:=SourceToHtml(dlgOpen.FileName,cbMono.Checked,True)
      else
         S:=SourceToRtf(dlgOpen.FileName,cbMono.Checked,True);
    except
      on EParserUnknown do
        S:=strFileLoad(dlgOpen.FileName);
      else raise ;
    end;

    aStop:=Time-aStop;
    Panel1.Caption := 'Time to parse : '+TimeToStr(aStop);

    if UseHtml then
       RichEdit1.Text := S
    else
       strToRichEdit(S, RichEdit1);
  end;
end;


procedure TfrmMain.cbMonoClick(Sender: TObject);
begin
  if cbMono.Checked then RichEdit1.Color:=clWhite
                    else RichEdit1.Color:=ColorWhite;
  Parse;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RichEdit1.Color:=ColorWhite;
end;

end.

